POJ 1734 Sightseeing trip (Floyd 最小环+记录路径)

Sightseeing trip

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 5040   Accepted: 1932   Special Judge

Description

There is a travel agency in Adelton town on Zanzibar island. It has decided to offer its clients, besides many other attractions, sightseeing the town. To earn as much as possible from this attraction,
the agency has accepted a shrewd decision: it is necessary to find the shortest route which begins and ends at the same place. Your task is to write a program which finds such a route.

In the town there are N crossing points numbered from 1 to N and M two-way roads numbered from 1 to M. Two crossing points can be connected by multiple roads, but no road connects a crossing point with itself. Each sightseeing route is a sequence of road numbers
y_1, ..., y_k, k>2. The road y_i (1<=i<=k-1) connects crossing points x_i and x_{i+1}, the road y_k connects crossing points x_k and x_1. All the numbers x_1,...,x_k should be different.The length of the sightseeing route is the sum of the lengths of all roads
on the sightseeing route, i.e. L(y_1)+L(y_2)+...+L(y_k) where L(y_i) is the length of the road y_i (1<=i<=k). Your program has to find such a sightseeing route, the length of which is minimal, or to specify that it is not possible,because there is no sightseeing
route in the town.

Input

The first line of input contains two positive integers: the number of crossing points N<=100 and the number of roads M<=10000. Each of the next M lines describes one road. It contains 3 positive integers:
the number of its first crossing point, the number of the second one, and the length of the road (a positive integer less than 500).

Output

There is only one line in output. It contains either a string ‘No solution.‘ in case there isn‘t any sightseeing route, or it contains the numbers of all crossing points on the shortest sightseeing
route in the order how to pass them (i.e. the numbers x_1 to x_k from our definition of a sightseeing route), separated by single spaces. If there are multiple sightseeing routes of the minimal length, you can output any one of them.

Sample Input

5 7
1 4 1
1 3 300
3 1 10
1 2 16
2 3 100
2 5 15
5 3 20

Sample Output

1 3 5 2

Source

CEOI 1999

题目连接:http://poj.org/problem?id=1734

题目大意:n个点,m条边的加权无向图,求其中的最小环,并输出路径

题目分析:Floyd的应用,很棒的应用,要求最小环,首先要找到环,找到的办法就是判断d[i][j] + map[i][k] + map[k][j] < INF是否成立,因为Floyd是按照结点的顺序更新最短路的,所以我们在更新最短路之前先找到一个连接点k,当前的点k肯定不存在于已存在的最短路d[i][j]的路径上,因为我们还没用这个k去更新最短路,相当于 (i -> k -> j -> j到i的最短路 -> i)这样一个环就找到了,接下来我们要记录路径,用path[i][j]表示在最短路i到j的路径上j的前一个结点,所以我们在更新最短路时也要更新这个点,原来的最短路是i
-> j,现在变成了 i -> k -> j,所以有path[i][j] = path[k][j],因为要找最小环,所以不断更新找到环的权值,环更新一次,路径也要更新一次,路径更新时根据path数组迭代一下就ok了

#include <cstdio>
#include <cstring>
int const MAX = 105;
int const INF = 0xfffffff;
int d[MAX][MAX], map[MAX][MAX], path[MAX][MAX];
int n, m, ans[MAX], mi, cnt;

void init()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            d[i][j] = INF;
            map[i][j] = INF;
            path[i][j] = i;
        }
    }
}

void Floyd()
{
    mi = INF;
    for(int k = 1; k <= n; k++)
    {
        //求环
        for(int i = 1; i < k; i++)
        {
            for(int j = 1; j < i; j++)
            {
                if(d[i][j] + map[i][k] + map[k][j] < mi)
                {
                    //此时的k值不在d[i][j]的路径中,所以找到一个环
                    mi = d[i][j] + map[i][k] + map[k][j];
                    //记录路径把j当起点顺序是: j -> j到i最短路的路径 -> i -> k
                    int tmp = j;
                    cnt = 0;
                    while(tmp != i)
                    {
                        ans[cnt++] = tmp;
                        tmp = path[i][tmp];
                    }
                    ans[cnt++] = i;
                    ans[cnt++] = k;
                }
            }
        }
        //求最短路
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                if(d[i][k] + d[k][j] < d[i][j])
                {
                    d[i][j] = d[i][k] + d[k][j];
                    //path[i][j]表示i到j最短路径上j前面的一个点
                    //所以此时i到j的最短路径上j前一个点为k到j最短路径上j的前一个点
                    path[i][j] = path[k][j];
                }
            }
        }
    }
}

int main()
{
    int u, v, w;
    scanf("%d %d", &n, &m);
    init();
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d %d", &u, &v, &w);
        if(d[u][v] > w)  //找最小环遇到平行边时取其最小边权
        {
            d[u][v] = d[v][u] = w;
            map[u][v] = map[v][u] = w;
        }
    }
    Floyd();
    if(mi == INF)
        printf("No solution.\n");
    else
    {
        printf("%d", ans[0]);
        for(int i = 1; i < cnt; i++)
            printf(" %d", ans[i]);
        printf("\n");
    }
}
时间: 2024-12-22 16:25:40

POJ 1734 Sightseeing trip (Floyd 最小环+记录路径)的相关文章

poj 1734 Sightseeing trip判断最短长度的环

Sightseeing trip Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 5590   Accepted: 2151   Special Judge Description There is a travel agency in Adelton town on Zanzibar island. It has decided to offer its clients, besides many other attra

POJ 1734.Sightseeing trip 解题报告

Floyd 最小环模板题 code /* floyd最小环,记录路径,时间复杂度O(n^3) 不能处理负环 */ #include <iostream> #include <cstring> using namespace std; const int INF = 109, maxn = 252645135; int g[INF][INF], dis[INF][INF], pre[INF][INF]; int ans[INF]; //pr[i][j]记录i到j最短路径的第一个点 i

URAL1004 Sightseeing Trip Floyd 最小环

题意:求有权无向图的最小环,环至少包括三个点. 思路: 设map[i,j]表示i到j的的距离.输入有重边,在处理输入的时候只保存最短边. 取环中一个点k,左右点是ij则map[i,k]和map[k,j]是固定的不能变,可改变的是没有加入k点的i,j之间的最短路,设为dist[i,j].那么最短环的长度表示为dist[i,j]+map[i,k]+map[k,j]. Floyd的最外层循环为k时,最短路还没有用k和更新ij之间的最短路,恰好符合要求.所以在还没有用k更新ij之间的最短路之前更新环,每

POJ 1734 Sightseeing trip

题目大意: 求一个最小环. 用Floyd 求最小环算法. #include <iostream> #include <cstdlib> #include <cstdio> #include <algorithm> #include <vector> #include <queue> #include <cmath> #include <cstring> using namespace std; #define

POJ-1734 Sightseeing trip(floyd求最小环)

Sightseeing trip Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6491   Accepted: 2486   Special Judge Description There is a travel agency in Adelton town on Zanzibar island. It has decided to offer its clients, besides many other attra

URAL 1004 Sightseeing Trip(最小环)

Sightseeing Trip Time limit: 0.5 secondMemory limit: 64 MB There is a travel agency in Adelton town on Zanzibar island. It has decided to offer its clients, besides many other attractions, sightseeing the town. To earn as much as possible from this a

【POJ1734】Sightseeing Trip 无向图最小环

题目大意:给定一个 N 个顶点的无向图,边有边权,如果存在,求出该无向图的最小环,即:边权和最小的环,并输出路径. 题解:由于无向图,且节点数较少,考虑 Floyd 算法,在最外层刚开始遍历到第 K 号节点时,\(d[i][j]\) 中记录着经过前 k-1 个点,从 i 到 j 的最短距离.因此,可以依次考虑每一个结构:\(\{d[i][j]+G[i][k]+G[k][j] \}\),这便是一个环形结构,每次更新答案贡献即可. 至于路径输出,\(get\_path(int\ i,int\ j)\

HDU 5137 How Many Maos Does the Guanxi Worth(floyd记录路径)

题意:给定N个点和M条边,点编号是1到N.现在要从2到N-1中选择一个删除,同时跟选择的点连接的边也就消失,然后使得点1到N的最短路径的长度最大.如果点1和点N不连通,则输出"Inf". 思路:直接暴力,枚举删去的点即可.我做了一步优化,只删原图最短路上的点, 所以用floyd的时候记录路径即可 //Accepted 1164 KB 0 ms #include<cstdio> #include<iostream> #include<cstring>

POJ 1734

被计组实验真冲昏了头脑..水一发先. 最小环+记录路径: 几个sb点.题目没看,以为是单向边.每次记录路径递归写重(开头结尾多记录一遍).重边忘处理. #include <cstdio> #include <cstring> #define INF 10000000 using namespace std; int n, m, x, y, mini, minj, g[105][105], k; int w[105][105], f[105][105], ans[105], min;